// TODO: must replace cog calculation with the one in netlayer class
//----------------------------------------------------------------------------
// 
//	file: hslissom.cc
// 
//	function: hierarchical slissom 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Mon Nov  9 07:24:08 CST 1998
// 
//	$Revision: 1.3 $ $Date: 2000/01/30 14:55:55 $
//	$Log: hslissom.cc,v $
//	Revision 1.3  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.2  1999/02/09 07:56:44  yschoe
//	*** empty log message ***
//
//	Revision 1.1  1998/11/17 12:49:46  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: slissom.cc
// 
//	function: test spikelayer class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sun Sep 27 05:49:27 CDT 1998
// 
//	$Revision: 1.3 $ $Date: 2000/01/30 14:55:55 $
//	$Log: hslissom.cc,v $
//	Revision 1.3  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.2  1999/02/09 07:56:44  yschoe
//	*** empty log message ***
//
//	Revision 1.1  1998/11/17 12:49:46  yschoe
//	Initial revision
//
//	Revision 1.6  1998/11/09 13:23:42  yschoe
//	*** empty log message ***
//
//	Revision 1.5  1998/10/26 04:02:22  yschoe
//	1. weight display windows added
//	2. network weight setup parameters added to blackboard for easier
//	   customization with the conf file
//	3. filename handling got better by the use of filename class.
//	4. simulation environment and network image separated.
//	5. command hooks used with the simulation environment.
//
//	Revision 1.4  1998/10/18 06:14:58  yschoe
//	*** empty log message ***
//
//	Revision 1.3  1998/10/16 10:35:21  yschoe
//	added randomness, and added a couple of display windows.
//
//	Revision 1.2  1998/10/05 19:59:23  yschoe
//	now capable of  gaussian initial weights.
//
//	Revision 1.1  1998/10/02 09:24:16  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: lissom.cc
// 
//	function: defines and implements LISSOM 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Wed Aug  5 18:04:55 CDT 1998
// 
//	Revision: 1.15 Date: 1998/09/14 06:03:04 
//	Log: lissom.cc,v -- see rlog
//
//----------------------------------------------------------------------------
#define lissom_version "slissom.cc $Revision: 1.3 $"

#include <iostream.h>
#include <nnview/spikelayer.h>
#include <nnview/simulog.h>
#include <nnview/real.h>
#include <nnview/coord.h>
#include <nnview/geninput.h>
#include <nnview/simenv.h>
#include <nnview/filename.h>

#ifndef LissomCUI
#include <window.h>
#include <nnview/plot_window.h>
#include <nnview/matrix_window.h>
#include <nnview/tool_window.h>
#include <nnview/net_window.h>
#include <nnview/disputil_window.h>
#include <nnview/gdb_visualize.h>
#include <nnview/affw_window.h>
#include <nnview/latw_window.h>
#include <nnview/simstat.h>
#endif


//----------------------------------------------------------------------------
// Network topology and simulation parameters
simenv	*environment;
simstat *stats;
simstat *stats2;
int 	N = 11;
int 	M = 11;
int 	INH_RAD = 11;
int 	EXC_RAD = 7;
int 	RF_RAD = 9;

int	H_N = 11;
int	H_EXC_RAD =5;
int	H_INH_RAD =11;
int 	H_RF_RAD = 9;

int 	GRAN = 5;
int 	WGT_GRAN = 2;
REAL 	LAMBDA_SYN = 0.3;
REAL 	LAMBDA_INH = 0.1;
REAL 	randomness=1.0;
REAL 	aff_setup_decay=0.5;
REAL 	lat_inh_setup_decay=1.0;
REAL 	lat_exc_setup_decay=3.0;
REAL 	sigmax=1.0;
REAL 	sigmay=1.0;
REAL 	wgt_disp_scale=1.0;
int 	disp_rate = 1;
int 	wgt_disp_rate = 1000;
int 	iters = 0;
int 	iters_per_run = 10;
int 	tsettle = 9;
int 	test_flag = 0;
char 	conffilename[100]; // config file base name
char 	buffname[100]; // config file base name

int     steps;
int 	t=0;
simulog	*netlog;

netlayer	*input;
spikelayer	*map;
spikelayer	*hmap;

coord		**cog;
coord		**ideal;

geninput	*input_generator; // input generator class

// End
//----------------------------------------------------------------------------

// prototypes
void run();
#ifndef LissomCUI
void affdisp();
#endif

//----------------------------------------------------------------------------
// GUI stuff
#ifndef LissomCUI

class mymain_window : public main_window {

public:
  mymain_window(char *name, int x, int y) : main_window(name,x,y) {
     selection_mask |= ButtonPressMask | ButtonReleaseMask | PointerMotionMask;
     polling_mode = False;
  }
  ~mymain_window(){};
  void polling_handler() {
	iters_per_run=1;
	run();
  }	
	
};

mymain_window     *mw;

plot_window     *pw ;
plot_window     *pw2 ;
plot_window     *pw3 ;

matrix_window   *matw;
matrix_window   *inpw;
matrix_window   *matw2;
matrix_window   *spikew;
matrix_window   *spikew2;
matrix_window   *avgw;

tool_window     *tw;

affw_window     *affdispw;
latw_window     *latinhdispw;
latw_window     *latexcdispw;
latw_window     *latcombdispw;

net_window	*nw;

callback_button *runit;
callback_button *testit;
callback_button *saveit;
callback_button *affdispit;
callback_button *commandit;

// Matrices for displaying
REAL		**spikeact;
REAL		**spikeact2;

#endif
// End: GUI stuff
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
//	chop() 
//	  - chop last entry in a string
//----------------------------------------------------------------------------
void chop(char *str) {

  str[strlen(str)-1] = '\0';

}

#ifndef LissomCUI
//----------------------------------------------------------------------------
//	disp_spikes() 
//	  - display spikes
//----------------------------------------------------------------------------
void disp_spikes() {

  static int count;

  for (int i=0; i<map->cols; ++i) 
     for (int j=0; j<map->rows; ++j) 
	spikeact[i][j] = (REAL)(map->spikeact_q[i][j]&0x1);

  for (int i=0; i<hmap->cols; ++i) 
     for (int j=0; j<hmap->rows; ++j) 
	spikeact2[i][j] = (REAL)(hmap->spikeact_q[i][j]&0x1);

  if (test_flag) {
    cout << "mua " << count << " " 
	//<< stats->sum_area(0,0,10,4) << " "
	//<< stats->sum_area(0,4,10,10) << endl;
	//--
	//<< stats->sum_area(0,0,10,4) << " " 
	//<< stats->sum_area(0,5,4,10) << " "
	//<< stats->sum_area(5,5,10,10) << endl;
	//--
	//<< stats->sum_area(0,0,10,3) << " " 
	//<< stats->sum_area(0,4,10,6) << " "
	//<< stats->sum_area(0,7,10,10) << endl;
	//-- [][] muas
	//<< stats->sum_area(0,0,5,10) << " " 
	//<< stats->sum_area(5,0,10,10) << endl;
	//-- == 
	//-- == 2 muas 
	//<< stats->sum_area(0,0,10,5) << " " 
	//<< stats->sum_area(0,5,10,10) << endl;
	//-- oo
	//   oo 4 muas
	<< stats->sum_area(0,0,4,4) << " "
	<< stats->sum_area(0,5,4,10) << " "
	<< stats->sum_area(5,0,10,4) << " "
	<< stats->sum_area(5,5,10,10) << endl;
    cout << "neuron_stat1 " << count << " "; map->print_stat(0,2,3);
    cout << "neuron_stat2 " << count << " "; map->print_stat(0,2,8);
    cout << "neuron_stat3 " << count << " "; map->print_stat(0,8,3);
    cout << "neuron_stat4 " << count << " "; map->print_stat(0,8,8);
    // cout << "neuron_stat1 " << count << " "; map->print_stat(0,5,2);
    // cout << "neuron_stat2 " << count << " "; map->print_stat(0,5,5);
    // cout << "neuron_stat3 " << count << " "; map->print_stat(0,5,8);
    count++;
	
  }

  spikew->redraw();
  spikew2->redraw();
  XFlush(display);  

}
#endif

//----------------------------------------------------------------------------
//      setup() 
//        - setup network for simulation
//----------------------------------------------------------------------------
void setup(int argc, char *argv[], char *configfile) {


  // copy config filename to conffilename
  netlog = new simulog(argv[0],filename::swap_ext(buffname,conffilename,"log"));

  netlog->append("command line %s %s ...",argv[0],argv[1]);
  netlog->append("code version: %s",lissom_version);
  netlog->append("code version: %s",netlayer_version);

  //
  // 1. Setup simulation environment
  //
  environment = new simenv("slissom environment",100);

  // 1.1 add local simulation parameters to the 
  // 	 blackboard 
  environment->add("N",&N);
  environment->add("M",&M);
  environment->add("INH_RAD", &INH_RAD);
  environment->add("EXC_RAD", &EXC_RAD);
  environment->add("RF_RAD", &RF_RAD);
  environment->add("LAMBDA_SYN", &LAMBDA_SYN);
  environment->add("LAMBDA_INH", &LAMBDA_INH);
  environment->add("GRAN",&GRAN);
  environment->add("WGT_GRAN",&WGT_GRAN);
  environment->add("randomness",&randomness);
  environment->add("aff_setup_decay",&aff_setup_decay);
  environment->add("lat_exc_setup_decay",&lat_exc_setup_decay);
  environment->add("lat_inh_setup_decay",&lat_inh_setup_decay);
  environment->add("wgt_disp_scale",&wgt_disp_scale);
  environment->add("sigmax",&sigmax);
  environment->add("sigmay",&sigmay);
  environment->add("iters",&iters);
  environment->add("disp_rate",&disp_rate);
  environment->add("wgt_disp_rate",&wgt_disp_rate);
  environment->add("iters_per_run",&iters_per_run);
  environment->add("tsettle",&tsettle);

  environment->add("H_N",&H_N);
  environment->add("H_INH_RAD", &H_INH_RAD);
  environment->add("H_EXC_RAD", &H_EXC_RAD);
  environment->add("H_RF_RAD", &H_RF_RAD);

  // 1.2 read from file and set up hook tables
  // 	 input layer
  int count = environment->parse_file(configfile);

  // 1.3 log the dimension and stuff
  netlog->append("N = %d (map NxN)",N);
  netlog->append("M = %d (input MxM)",M);
  netlog->append("randomness = %f",randomness);

  //
  // 2. Set up map layers, and register maps in the environment, then
  //	run hooks
  //
  
  // 2.1 Input layer
  cout << "Initializing input layer.\n";
  input = new netlayer("input",M,M,0,0,0);
  
  // 2.2 SLISSOM layer
  cout << "Initializing map layer.\n";
  map   = new spikelayer("map",N,N,EXC_RAD,INH_RAD,2,input,M,M,RF_RAD,
		LAMBDA_SYN,LAMBDA_INH,0.4,0.5);

  // 2.3 Higher layer coarse resolution map
  hmap = new spikelayer("high",H_N,H_N,H_EXC_RAD,H_INH_RAD,1,input,
		M,M,H_RF_RAD,LAMBDA_SYN,LAMBDA_INH,0.4,0.5);

  // 2.4 Add Higher layer feedback to SLISSOM layer
  map->add_inp_layer(hmap,H_N,H_N,1);

  // 2.3 add the spike layer to the environment, and add commands
  environment->add_obj("slissom",map,"slissom layer");
  environment->add_cmd("slissom->call_resize_lat_exc_rad","slissom",
	&spikelayer::call_resize_lat_exc_rad, 1, 
	" <int-new radius");
  environment->add_obj("hslissom",hmap,"higher slissom layer");

  // 2.4 execute init_hooks before proceeding
  environment->run_hooks_init();

  //
  // 3. init weights
  //
  map->init_weights(0.0,randomness);
  map->setup_weight(NETWGT_AFF,(REAL)aff_setup_decay,randomness);
  map->setup_weight(NETWGT_INH,(REAL)lat_inh_setup_decay,randomness);
  map->setup_weight(NETWGT_EXC,(REAL)lat_exc_setup_decay,randomness);
  map->normalize_weights();

  hmap->init_weights(0.0,randomness);
  hmap->setup_weight(NETWGT_AFF,(REAL)aff_setup_decay,randomness);
  hmap->setup_weight(NETWGT_INH,(REAL)lat_inh_setup_decay,randomness);
  hmap->setup_weight(NETWGT_EXC,(REAL)lat_exc_setup_decay,randomness);
  hmap->normalize_weights();

  // 
  // 4. set up ideal grid and COG matrix : todo -- this may go into netlayer
  //	class
  //
  
  // 4.1 Ideal grid
  ideal = new coord* [N];
  for (int i=0; i<N; ++i) 
	ideal[i] = new coord [N];

  for (int i=0; i<map->cols; ++i) {
    for (int j=0; j<map->rows; ++j) {
       ideal[i][j].x = (REAL) i*M/(REAL)N;
       ideal[i][j].y = (REAL) j*M/(REAL)N;
    }
  }

  // 4.2 set up COG (center of gravity) map
  cog = new coord* [N];
  for (int i=0; i<N; ++i) 
	cog[i] = new coord [N];

}

//----------------------------------------------------------------------------
//	calc_cog() 
//	  - calculate center of gravity coordinates
//----------------------------------------------------------------------------
void calc_cog(coord **cog, netlayer *map, int cur_inp_layer){

  REAL sum, x_sum, y_sum;
  for (int x=0; x<map->cols; ++x) {

     for (int y=0; y<map->rows; ++y) {

	sum = 0.0;
	x_sum = 0.0;
	y_sum = 0.0;
	for (int i=map->rf_ranges[cur_inp_layer][x][y].lowx;
		 i<=map->rf_ranges[cur_inp_layer][x][y].highx; ++i) {
	   for (int j=map->rf_ranges[cur_inp_layer][x][y].lowy;
		    j<=map->rf_ranges[cur_inp_layer][x][y].highy; ++j) {
		int rf_x = i-map->rf_ranges[cur_inp_layer][x][y].lowx;
		int rf_y = j-map->rf_ranges[cur_inp_layer][x][y].lowy;
		REAL wgt = map->wgt[x][y].aff_ws[cur_inp_layer][rf_x][rf_y];
		sum += wgt;
		x_sum += i*wgt;
		y_sum += j*wgt;
	   }
      	}	
	cog[x][y].x = x_sum/sum;
	cog[x][y].y = y_sum/sum;	
     }
  }
}

//----------------------------------------------------------------------------
//      run() 
//        - bplayer : run a certain number of backprop learning
//----------------------------------------------------------------------------
void run () {

  char str[100];
  int i;

  cout << "environment->list_scalar() <<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
  environment->list_scalar();
  cout << "map->net_bb->list_scalar() <<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
  map->net_bb->list_scalar();
  cout << "hmap->net_bb->list_scalar() <<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
  hmap->net_bb->list_scalar();

  // for the number of given steps
  for (i=t; i<t+iters_per_run; ++i) {

    // Run hooks
    environment->run_hooks_before(i);

    //
    // 1. set input and normalize
    //
    REAL sum=0.0;
    input_generator->clear_input();
    /* Gaussian */
    if (test_flag) {
    	//input_generator->add_input(5,5,1);
	//-- 2 boxes
    	//input_generator->add_input(8,8,1);
    	//input_generator->add_input(2,2,1);
	//-- 3 boxes
    	//input_generator->add_input(2,8,1);
    	//input_generator->add_input(8,8,1);
    	//input_generator->add_input(5,2,1);
	//-- 1 bar
    	//input_generator->add_input(5,8,1);
    	//input_generator->add_input(5,5,1);
    	//input_generator->add_input(5,2,1);
  	//-- 2 bars
    	input_generator->add_input(2,8,1);
    	input_generator->add_input(2,5,1);
    	input_generator->add_input(2,2,1);
    	input_generator->add_input(8,8,1);
    	input_generator->add_input(8,5,1);
    	input_generator->add_input(8,2,1);
    } else {
	if (sigmay>1.0) {
    	input_generator->add_input((int)(drand48()*M),(int)(drand48()*M),
			(REAL)sigmax, (REAL)sigmay, (REAL)(drand48()*360.0));
	} else {
    	input_generator->add_input((int)(drand48()*M),(int)(drand48()*M),
		1);
	}
    }
 
#   ifndef LissomCUI
    if (i%disp_rate==0) { inpw->redraw(); XFlush(display); }
#   endif

    // clear map activity
    // map->reset_output();

    // activate and settle
    int settling = test_flag ? 1 : tsettle;
    for (int k=0; k<settling ; ++k) {

	hmap->activate();
	map->activate(); 

	// display
        if (i%disp_rate==0) {
#	    	ifndef LissomCUI
		// calculate c.o.g.  
		calc_cog(cog,map,0); nw->redraw(); mw->redraw(); disp_spikes();
		matw->redraw();
#	    	else
		if (k==0) { cout << "iter " << i << endl; }
#	    	endif
	}	
#       ifndef LissomCUI
	set_color(white); 
	XFillRectangle(display,mw->Win,gc_copy,
		0,mw->height-20,mw->width,20);	
	set_color(black); sprintf(str,"settle=%d",k);
	mw->DrawString(0,mw->height-10,str); sprintf(str,"iter=%d",i);
	mw->DrawString(0,mw->height,str); XFlush(display);
    	if (i%disp_rate==0) {
    		avgw->redraw(); XFlush(display);
    	}
#   endif

    } // end of settling loop

    // learn weights
    hmap->learn();
    hmap->normalize_weights();
    map->learn();
    map->normalize_weights();

    // Run hooks
    environment->run_hooks_after(i);
    
    // log every 1000 iterations
    if (i%disp_rate==0) {
	netlog->append("iter %d reached.",i);
    }
#   ifndef LissomCUI
    if (i%wgt_disp_rate==0) {
	affdisp();
    }
#   endif

  } // end of big loop

  // set start of next run
  t = i;

}


//----------------------------------------------------------------------------
//	test() 
//	  - testing mode
//----------------------------------------------------------------------------
void test() {

  test_flag = 1;

  run();

}

//----------------------------------------------------------------------------
//	save() 
//	  - save blackboard
//----------------------------------------------------------------------------
void save() {

  cout << "lissom.cc: saveit() : saving to lissom.sav\n";
  map->net_bb->save(filename::swap_ext(buffname,conffilename,"mapsav"));
  hmap->net_bb->save(filename::swap_ext(buffname,conffilename,"hmapsav"));
  //dispmat(map->output,36,36,5);

}

#ifndef LissomCUI
//----------------------------------------------------------------------------
//	affdisp() 
//	  - popup and display afferent weights
//----------------------------------------------------------------------------
void affdisp() {

  static int toggled=0;

  affdispw->set_scale(wgt_disp_scale);
  latinhdispw->set_scale(wgt_disp_scale);
  latexcdispw->set_scale(wgt_disp_scale);
  latcombdispw->redraw();

  if (!toggled) {
  	affdispw->toggle();
  	latinhdispw->toggle();
  	latexcdispw->toggle();
  	latcombdispw->toggle();
	toggled=1;
  } else {
  	// affdispw->redraw();
  	// affdispw->redraw();
  	latinhdispw->redraw();
  	latinhdispw->redraw();
  	// latexcdispw->redraw();
  	// latexcdispw->redraw();
  	// latcombdispw->redraw();
  	// latcombdispw->redraw();
  }	

}

//----------------------------------------------------------------------------
//	command() 
//	  - read input and run command
//----------------------------------------------------------------------------
void command() {

  char command[256];

  cout << "slissom command shell : type 'quit' to end command session."<< endl;
  cout << "slissom> ";
  fgets(command,255,stdin);
  while (strncmp(command,"quit",4)!=0) {
	// check if it is a local command
	if (strncmp(command,"run",3)==0) {
		run();
	} else if (strncmp(command,"disp_wgt",8)==0) {
		affdisp();
	} else if (strncmp(command,"save",4)==0) {
		save();
	} else {	
		environment->parse(command);
	}
  	cout << "slissom> ";
  	fgets(command,255,stdin);
  }

}

//----------------------------------------------------------------------------
//	gdb_dispmat() 
//	  - for debugging, display arbirtaty map
//----------------------------------------------------------------------------
void gdb_dispmat(REAL **mat, int cols, int rows, int gran) {

  disputil_window *dw = new disputil_window("gdb vis",mat,rows,cols,gran);
  unmap_button *dwclose = new unmap_button(*dw,"close",cols*gran,20,0,rows*gran);  
  dw->toggle();

}
#endif

//----------------------------------------------------------------------------
//	main() 
//	  - the MAIN
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

  steps = 20000;
  t 	= 0;

  // 1. check args
  if (argc < 2) {
	cout << "usage: " << argv[0] 
	     << " <configfilename> [<network imagefile> <img2>] [<start t>]\n";
 	exit(0);
  } 

  // 1.1 save config filename
  strncpy(conffilename,argv[1],strlen(argv[1])+1);

  // 2.1 setup network and allocate memory

  setup(argc,argv,argv[1]);
#ifndef LissomCUI
  spikeact = new REAL* [N];
  for (int i=0; i<N; ++i) spikeact[i] = new REAL [N];
  spikeact2 = new REAL* [H_N];
  for (int i=0; i<N; ++i) spikeact2[i] = new REAL [N];
  
  stats       = new simstat(spikeact, N, N);
  stats2       = new simstat(spikeact, H_N, H_N);

#endif

  // 2.2 if network imagefilename given, load the network image
  if (argc >= 5) {
	
	cout << "lissom.cc : main() : setting t = " << argv[3] << "\n";
	t = atoi(argv[3]);

	// now go through all hooks so that the simulation environment
	// is the same as when the image was saved
        cout << "lissom.cc : main() : redoing all hooks " << endl;
	environment->rerun_hooks(t-1);	
	cout << "lissom.cc : main() : loading image " << argv[2] << "\n";
	map->net_bb->load(argv[2]);
	hmap->net_bb->load(argv[3]);

  }

  // 3. setup input generator
  input_generator = new geninput(input->output,M,M,INP_ORI_BAR,INP_NORM_SQRT);
  input_generator->clear_input();

# ifndef LissomCUI

  //
  // 4.1. GUI Interface
  //

  // setup the windows
  mw = new mymain_window(argv[0],N*GRAN*3,N*GRAN*2+40);
  
  matw = new matrix_window(*mw,N*GRAN,N*GRAN,0,0,0,60,COLOR,N,N,map->lfp);  


  spikew = new matrix_window(*mw,(int)(N*GRAN/2.5),(int)(N*GRAN/2.5)
		,N*GRAN+5,N*GRAN+5,0,60,
		COLOR,N,N,spikeact);  

  avgw   = new matrix_window(*mw,(int)(N*GRAN/2.5),(int)(N*GRAN/2.5), 
		N*GRAN+N*GRAN/2+5,N*GRAN+5,0,60,
		COLOR,N,N,map->avg_spiking);  
  avgw->set_scale(2.5);

  // hmap 
  matw2 = new matrix_window(*mw,(int)(H_N*GRAN/2.5),(int)(H_N*GRAN/2.5),
		2*N*GRAN+5,N*GRAN+5,0,60,COLOR,N,N,hmap->lfp);  

  spikew2 = new matrix_window(*mw,(int)(H_N*GRAN/2.5),(int)(H_N*GRAN/2.5)
		,(int)(2.5*N*GRAN)+5,N*GRAN+5,0,60,
		COLOR,H_N,H_N,spikeact2); // spikeact2);  


  inpw = new matrix_window(*mw,M*GRAN,M*GRAN,0,N*GRAN+10,0,60,
		COLOR,M,M,input->output);  

  nw = new net_window(*mw,N*GRAN,N*GRAN,N*GRAN,0,0,GRAN,
		COLOR,N,N,0.0,1.0,0.0,1.0,cog,ideal);

  // weight display
  affdispw = new affw_window("Afferent weight", map,
			N*(M+1)*WGT_GRAN,N*(M+1)*WGT_GRAN);

  latinhdispw = new latw_window("Lateral inh weight",map,
			N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
			LATW_INH,10.0);
  latexcdispw = new latw_window("Lateral exc weight",map,
			N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
			LATW_EXC,10.0);
  latcombdispw = new latw_window("Combined lateral weight",map,
			N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN, 
			LATW_COMB,10.0);

  // Buttons
  runit = new callback_button(*mw,"Run",run,
                mw->width/8,20,mw->width*4/8,mw->height-20);

  saveit = new callback_button(*mw,"Save",save,
		mw->width/8,20,mw->width*5/8,mw->height-20);
 
  testit = new callback_button(*mw,"Test",test,
                mw->width/8,20,mw->width*6/8,mw->height-20);

  affdispit = new callback_button(*mw,"Wgt Disp",affdisp,
                mw->width/8,20,mw->width*3/8,mw->height-20);

  commandit = new callback_button(*mw,"Cmd",command,
                mw->width/8,20,mw->width*2/8,mw->height-20);

  new quit_button(*mw,mw->width/8,20,mw->width*7/8,mw->height-20);

  matw->redraw();
  nw->redraw();

  // start main loop
  mw->main_loop();

  // deallocate stuff
  for (int i=0; i<N; ++i) delete [] spikeact[i];
  delete [] spikeact;
  for (int i=0; i<H_N; ++i) delete [] spikeact2[i];
  delete [] spikeact2;

# else

  //
  // 4.2. Text interface
  //
  run();
  map->save("tlissom.sav");

# endif

  delete netlog;

}

