## usage: histo(X,n)
##
## Returns a [index, histo] (n-vectors) containing the histogram index
## and the counts.
##

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function [idx,hist] = histo(X,n) 

  minval = min(min(X));
  maxval = max(max(X));
  diff = maxval-minval;

  hist=[1:n];
  idx=[1:n];
  for i = 1 : n;   # rows
	hist(i)=0;
   	idx(i)=(i-1)/(n-1)*diff+minval;
  endfor

  for i = 1 : length(X(:,1));   # rows
    for j = 1 : length(X(1,:)); # cols
	m = max(min((X(i,j)-minval)/diff*n-1,n),1);
	hist(m) = hist(m) + 1;
    endfor
  endfor

endfunction

