#!/usr/bin/wish

global cog_size retina_size cog cog2 rf_radius ormap ormap2 disp_mode grad grad2 selec selec2

#----------------------------------------------------------------------------
# 	fix: 	limit 'idx' between [0..$size-1]
#----------------------------------------------------------------------------
proc fix { idx size } {

  if { $idx < 0 } {
	return 0;
  }

  if { $idx >= $size } {
	set ret [expr $size - 1 ];
	return $ret
  } else {
	return $idx
  }
}
#----------------------------------------------------------------------------
# 	hsvtorgb
#----------------------------------------------------------------------------
proc HSVToRGB { colorBoxHue colorBoxSat colorBoxValue} {
# xf ignore me 6
# The HSV <-> RGB converting routines are from the
# tcolor demo that is part of the demo site of Tk.
# From: 
# http://www.mit.edu/afs/sipb/project/tcl/linuxbin/xfpixmap
#!/afs/sipb/project/tcl/wish -f
# Program: xfpixmap
# Tcl version: 6.6 (Tcl/Tk/XF)
# Tk version: 3.1
# XF version: $__lastrelease$

  set colorBoxV [format %.0f [expr 255.0*$colorBoxValue]]
  if {$colorBoxSat == 0} {
    return [format "#%02x%02x%02x" $colorBoxV $colorBoxV $colorBoxV]
  } else {
    set colorBoxHue [expr $colorBoxHue*6.0]
    if {$colorBoxHue >= 6.0} {
      set colorBoxHue 0.0
    }
    scan $colorBoxHue. %d i
    set colorBoxF [expr $colorBoxHue-$i]
    set colorBoxP [format %.0f [expr {255.0*$colorBoxValue*(1 - $colorBoxSat)}]]
    set colorBoxQ [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*$colorBoxF))}]]
    set colorBoxT [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*(1 - $colorBoxF)))}]]
    case $i       0 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxT $colorBoxP]} \
      1 {return [format "#%02x%02x%02x" $colorBoxQ $colorBoxV $colorBoxP]} \
      2 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxV $colorBoxT]} \
      3 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxQ $colorBoxV]} \
      4 {return [format "#%02x%02x%02x" $colorBoxT $colorBoxP $colorBoxV]} \
      5 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxP $colorBoxQ]}
    puts stderr "i value $i is out of range"
  }
}

#----------------------------------------------------------------------------
# 	plotnet: plot c.o.g.s net 
#----------------------------------------------------------------------------
proc plotnet { size } {

  global cog_size retina_size rf_radius cog cog2 ormap ormap2 disp_mode grad grad2 selec selec2
  global line line2

  set gran [expr int($cog_size/$retina_size)] 
  if { $gran==0 } {
	set gran 1
  } 

  puts stderr "display mode = $disp_mode"

  if {[string compare $disp_mode "skip"] == 0} {
	set skip 3
  } else {	
	set skip 1
  }

  #--------------------
  # clear existing lines
  #--------------------
  .misc.net addtag allLines all
  .misc.net delete allLines
	 
  if {[string compare $disp_mode "grad"] == 0} {
	  for {set x 0} {$x<$size} {incr x} {
	     for {set y 0} {$y<$size} {incr y} {

		  #--------------------
		  # current node
		  #--------------------
		  set c $cog($x-$y)
		  set cl [split $c ":"]
		  set cx [expr [lindex $cl 0]]
		  set cy [expr -[lindex $cl 1]+$retina_size-1]

		  #--------------------
		  # x neighbor
		  #--------------------
		  if {$x == [expr $size-1]} {
			set xplus [expr $x-1]
		  } else {
			set xplus [expr $x+1]
		  }
		  set nx $cog($xplus-$y)
		  set nxl [split $nx ":"]
		  set nxx [expr [lindex $nxl 0]]
		  set nxy [expr -[lindex $nxl 1]+$retina_size-1]

		  #--------------------
		  # y neighbor
		  #--------------------
		  if {$y == [expr $size-1]} {
			set yplus [expr $y-1]
		  } else {
			set yplus [expr $y+1]
		  }
		  set ny $cog($x-$yplus)
		  set nyl [split $ny ":"]
		  set nyx [expr [lindex $nyl 0]]
		  set nyy [expr -[lindex $nyl 1]+$retina_size-1]

		  set width 1

		  set val [expr int($grad($x-$y)*255*5)]
		  if { $val > 255 } {
				set val 255
		  }
		  #set color [format "#%02x0000" $val]
		  set color [format "#ff%02x%02x" \
					[expr 255-$val] [expr 255-$val]]
		  # set width [expr int($val/128)]
		  if {$grad($x-$y)>0.5} {
			set width 3
		  } else {
			set width 0
		  }
		  .misc.net create oval \
				[expr int($cx*$gran)-$width]  \
				[expr int($cy*$gran)-$width]  \
				[expr int($cx*$gran)+$width]  \
				[expr int($cy*$gran)+$width]  \
				-fill $color -outline $color 
				
		  } 

	    }
  }

  for {set x 0} {$x<$size} {incr x} {
     for {set y 0} {$y<$size} {incr y} {

  	  #--------------------
	  # current node
  	  #--------------------
	  set c $cog($x-$y)
	  set cl [split $c ":"]
	  set cx [expr [lindex $cl 0]]
	  set cy [expr -[lindex $cl 1]+$retina_size-1]

  	  #--------------------
	  # x neighbor
  	  #--------------------
	  if {$x == [expr $size-1]} {
	  	set xplus [expr $x-$skip]
	  } else {
	  	set xplus [expr $x+$skip]
	  }
	  set nx $cog($xplus-$y)
	  set nxl [split $nx ":"]
	  set nxx [expr [lindex $nxl 0]]
	  set nxy [expr -[lindex $nxl 1]+$retina_size-1]

  	  #--------------------
	  # y neighbor
  	  #--------------------
	  if {$y == [expr $size-1]} {
	  	set yplus [expr $y-$skip]
	  } else {
	  	set yplus [expr $y+$skip]
	  }
	  set ny $cog($x-$yplus)
	  set nyl [split $ny ":"]
	  set nyx [expr [lindex $nyl 0]]
	  set nyy [expr -[lindex $nyl 1]+$retina_size-1]

	  set width 1

	  set color "\#000000"

	  if {[string compare $disp_mode "or"] == 0} {
	  	# set val [expr int($ormap($x-$y)*255)]
	  	# set color [format "#%02x%02x%02x" $val $val $val]
		set color [HSVToRGB $ormap($x-$y) 1 1]
	  } elseif {[string compare $disp_mode "grad"] == 0} {
	  	set val [expr int($grad($x-$y)*255*3)]
		if { $val > 255 } {
			set val 255
		}
	  	#set color [format "#%02x0000" $val]
	  	set color [format "#ff%02x%02x" \
				[expr 255-$val] [expr 255-$val]]
		set width [expr int($grad($x-$y)*2)]
		set color "\#000000"
	  } elseif {[string compare $disp_mode "selec"] == 0} {
		if { $selec($x-$y) < 0.7 } {
			set val 220
	  		set color [format "#%02x%02x%02x" $val 0 0  ]
		} else {
			set val 0
	  		set color [format "#%02x%02x%02x" $val $val $val ]
		}
	  } else {
		set color "\#000000"
	  }

	  if {$width>2} {
	   	set width 2
	  }

	  set width 1

	  .misc.net create line [expr int($cx*$gran)] [expr int($cy*$gran)] \
		[expr int($nxx*$gran)] [expr int($nxy*$gran)] \
		 -fill $color -width $width
	  .misc.net create line [expr int($cx*$gran)] [expr int($cy*$gran)] \
		[expr int($nyx*$gran)] [expr int($nyy*$gran)] \
		 -fill $color -width $width

	  if {[string compare $disp_mode "skip"] == 0} {
		set y [expr $y+$skip-1]
	  }
    }
    if {[string compare $disp_mode "skip"] == 0} {
		set x [expr $x+$skip-1]
    }
  }

}

#----------------------------------------------------------------------------
#
# 	MAIN:
#
#----------------------------------------------------------------------------
if {[llength $argv] <= 0} {
  puts "usage: printcog2.tcl <size> <zoom> <ppm_filename2> <or_filaname2>"
  puts "	<size2> <ppm_filename2> <or_filename2>"
  puts " 	<cog_filename1> <cog_filename2> <retina_size> <rfradius>"
  puts " 	<disp_mode> <gradient1> <gradient2> <orselec> <orselec2>" 
  exit
}

set size [lindex $argv 0]
set zoom [lindex $argv 1]

set orfile [lindex $argv 3]
set orfile2 [lindex $argv 6]

set size2 [lindex $argv 4]

set retina_size [lindex $argv 9]

set mag [expr $size/$retina_size]
set mag2 [expr $size2/$retina_size]

set disp_mode [lindex $argv 11]

set gradfile [lindex $argv 12]
set gradfile2 [lindex $argv 13]

set selecfile [lindex $argv 14]
set selecfile2 [lindex $argv 15]

#----------------------------------------
# 3.1 Load COG1 : each loaded cog items are in the format of "x:y"
#----------------------------------------
set fp [open [lindex $argv 7]]
for {set i 0} {$i<$size} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set cog(${j}-${i}) [lindex $cols $j]
	# regsub ?switches? exp string subSpec varName
	set replace_x [expr $i*$retina_size/$size]
	set replace_y [expr $j*$retina_size/$size]
	set replace_str "$replace_x:$replace_y"
	regsub "nan:nan" $cog(${j}-${i}) "$replace_str" cog(${j}-${i})
  }

}
close $fp

#----------------------------------------
# 3.2 Load COG2
#----------------------------------------
set fp [open [lindex $argv 8]]
for {set i 0} {$i<$size2} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set cog2(${j}-${i}) [lindex $cols $j]
  }

}
close $fp

#----------------------------------------
# 4.1 Load OR1 
#----------------------------------------
if { [file exists $orfile]==1 } {
set fp [open $orfile]
for {set i 0} {$i<$size} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set ormap(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}


#----------------------------------------
# 4.2 Load OR2
#----------------------------------------
if { [file exists $orfile2]==1 } {
set fp [open $orfile2]
for {set i 0} {$i<$size2} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set ormap2(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}

#----------------------------------------
# 5.1 Load grad1 
#----------------------------------------
if { [file exists $gradfile]==1 } {
set fp [open $gradfile]
for {set i 0} {$i<$size} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set grad(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}


#----------------------------------------
# 5.2 Load grad2
#----------------------------------------
if { [file exists $gradfile2]==1 } {
set fp [open $gradfile2]
for {set i 0} {$i<$size2} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set grad2(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}

#----------------------------------------
# 6.1 Load selec
#----------------------------------------
if { [file exists $selecfile]==1 } {
puts stderr "** loading $selecfile"
set fp [open $selecfile]
for {set i 0} {$i<$size} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set selec(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}


#----------------------------------------
# 6.2 Load selec2 
#----------------------------------------
if { [file exists $selecfile2]==1 } {
set fp [open $selecfile2]
for {set i 0} {$i<$size2} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  for {set j 0} {$j<=[expr [llength $cols]-1]} {incr j} {
	set selec2(${j}-${i}) [lindex $cols $j]
  }

}
close $fp
}

#----------------------------------------------------------------------------

if {$retina_size<30} {
	set cog_size 125
} else {
	set cog_size [expr $retina_size * 4]
}

set rf_radius [lindex $argv 10]
set cog_size [expr $cog_size * $zoom]

#----------------------------------------
# 6. Create COG / Orientation display frame
#----------------------------------------
frame .misc -relief ridge; pack .misc -padx 10 -pady 10

if {[string compare $disp_mode "or"] == 0} {
	set bgcolor "black"
} else {
	set bgcolor "white" 
}
canvas .misc.net -relief sunken -borderwidth 1 -background $bgcolor\
	-width [expr $cog_size] -height [expr $cog_size];

pack .misc.net -side left -padx 10 -pady 5 ; 

puts stderr "** mode is $disp_mode"

plotnet $size

#----------------------------------------
# 7. Add clear and quit button
#----------------------------------------
frame .buttons
pack .buttons -side top -padx 5 -pady 5 

button .buttons.psdump -command { \
	.misc.net postscript -file ormapview.net.ps ; \
	} -text "PS Dump"
pack .buttons.psdump -side left
	
button .buttons.quit -command { puts " "; exit } -text "Quit"
pack .buttons.quit -side left -padx 10 -pady 10

