#!/usr/bin/perl

# run lissom simulation with saved ormap and network image dumps

#----------------------------------------
# usage info
#----------------------------------------
$usage = <<'EOF' ;
usage: runslissom.pl [-x] <n> <conf-file>

	-x  : start with X11 interface (default is off)
	<n> : save file iteration
	<conf-file> : configuration file name

EOF

#----------------------------------------
# Process command line arguments
#----------------------------------------
require "getopts.pl";
&Getopts('x');

if ($#ARGV!=1) {
	print $usage;
	exit;
}
	
$lissom_command = $opt_x?"slissom2-2":"tslissom2-2";

$iter = $ARGV[0];
$conf = $ARGV[1];

#--------------------
# get conf file prefix
#--------------------
($prefix,$junk) = split (/\.conf/,$conf);

#--------------------
# make save filenames
#--------------------
$formatted_iter = sprintf("%06d",$iter);
$sav1 = "$prefix.$iter-map1.sav";
$sav2 = "$prefix.$iter-map2.sav";

$or1 = "$prefix.$formatted_iter.map1-0.or";
$or2 = "$prefix.$formatted_iter.map2-0.or";

#----------------------------------------
# Format command line and execute
#----------------------------------------

$iter++;

$command = "$lissom_command $conf $sav1 $sav2 $iter $or1 $or2";

print "** Executing: $command\n";
system("$command");


